diff --git a/libavfilter/avfilter.c b/libavfilter/avfilter.c
index 22a1fedd17..e2eb2980be 100644
--- a/libavfilter/avfilter.c
+++ b/libavfilter/avfilter.c
@@ -1498,6 +1498,69 @@ int ff_link_acknowledge_status(AVFilterLink *link)
     return 1;
 }
 
+int ff_link_check_available_frame(AVFilterLink *link)
+{
+    return ff_framequeue_queued_frames(&link->fifo) > 0;
+}
+
+int ff_link_check_available_samples(AVFilterLink *link, unsigned min)
+{
+    uint64_t samples = ff_framequeue_queued_samples(&link->fifo);
+    av_assert1(min);
+    return samples >= min || (link->status_in && samples);
+}
+
+static void consume_update(AVFilterLink *link, const AVFrame *frame)
+{
+    ff_link_process_commands(link, frame);
+    ff_link_process_timeline(link, frame);
+    link->frame_count_out++;
+}
+
+int ff_link_consume_frame_sure(AVFilterLink *link, AVFrame **rframe)
+{
+    AVFrame *frame;
+
+    av_assert1(ff_link_check_available_frame(link));
+    frame = ff_framequeue_take(&link->fifo);
+    consume_update(link, frame);
+    *rframe = frame;
+    return 1;
+}
+
+int ff_link_consume_samples_sure(AVFilterLink *link, unsigned min, unsigned max,
+                                 AVFrame **rframe)
+{
+    AVFrame *frame;
+    int ret;
+
+    av_assert1(min);
+    av_assert1(ff_link_check_available_samples(link, min));
+    if (link->status_in)
+        min = FFMIN(min, ff_framequeue_queued_samples(&link->fifo));
+    ret = take_samples(link, min, link->max_samples, &frame);
+    if (ret < 0)
+        return ret;
+    consume_update(link, frame);
+    *rframe = frame;
+    return 1;
+}
+
+int ff_link_consume_frame(AVFilterLink *link, AVFrame **rframe)
+{
+    *rframe = NULL;
+    return !ff_link_check_available_frame(link) ? 0 :
+            ff_link_consume_frame_sure(link, rframe);
+}
+
+int ff_link_consume_samples(AVFilterLink *link, unsigned min, unsigned max,
+                            AVFrame **rframe)
+{
+    *rframe = NULL;
+    return !ff_link_check_available_samples(link, min) ? 0 :
+            ff_link_consume_samples_sure(link, min, max, rframe);
+}
+
 int ff_link_make_frame_writable(AVFilterLink *link, AVFrame **rframe)
 {
     AVFrame *frame = *rframe;
diff --git a/libavfilter/internal.h b/libavfilter/internal.h
index 4488821fe0..9aaf585eca 100644
--- a/libavfilter/internal.h
+++ b/libavfilter/internal.h
@@ -625,6 +625,53 @@ void ff_filter_set_ready(AVFilterContext *filter, unsigned priority);
 int ff_link_acknowledge_status(AVFilterLink *link);
 
 /**
+ * Test if a frame is available on the link.
+ * @return  >0 if a frame is available
+ */
+int ff_link_check_available_frame(AVFilterLink *link);
+
+/**
+ * Test if enough samples are available on the link.
+ * @return  >0 if enough samples are available
+ * @note  on EOF and error, min becomes 1
+ */
+int ff_link_check_available_samples(AVFilterLink *link, unsigned min);
+
+/**
+ * Take a frame from the link's FIFO and update the link's stats.
+ * Must only be called if a frame is available (assert1).
+ * @note  May trigger process_command() and/or update is_disabled.
+ */
+int ff_link_consume_frame_sure(AVFilterLink *link, AVFrame **rframe);
+
+/**
+ * Take samples from the link's FIFO and update the link's stats.
+ * Must only be called if samples are available (assert1).
+ * @note  May trigger process_command() and/or update is_disabled.
+ */
+int ff_link_consume_samples_sure(AVFilterLink *link, unsigned min, unsigned max,
+                                 AVFrame **rframe);
+
+/**
+ * Take a frame from the link's FIFO and update the link's stats.
+ * @note  May trigger process_command() and/or update is_disabled.
+ * @return  >0 if a frame is available,
+ *          0 and sets rframe to NULL if no frame available,
+ *          or AVERROR code
+ */
+int ff_link_consume_frame(AVFilterLink *link, AVFrame **rframe);
+
+/**
+ * Take samples from the link's FIFO and update the link's stats.
+ * @note  May trigger process_command() and/or update is_disabled.
+ * @return  >0 if a frame is available,
+ *          0 and sets rframe to NULL if no frame available,
+ *          or AVERROR code
+ */
+int ff_link_consume_samples(AVFilterLink *link, unsigned min, unsigned max,
+                            AVFrame **rframe);
+
+/**
  * Make sure a frame is writable.
  * This is similar to av_frame_make_writable() except it uses the link's
  * buffer allocation callback, and therefore allows direct rendering.